﻿; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
;         Awesomium - Browser Framework based on Chromium
;
;                           gadget example (small browser)
;
; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
; from: 16.02.2012
; Version 0.04.00
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
;
; © 2012 by PMV 
; 
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
; thread: http://www.purebasic.fr/english/viewtopic.php?f=12&t=48283
; custom TabBar by STARGÅTE: http://www.purebasic.fr/english/viewtopic.php?f=12&t=47588
;
; description: shows how Awesomium can be used to display it
;              as a gadget (canvas gadget). Remember, it is a
;              full browser-engine, so you can display here 
;              everything, what Chrome can render. You can
;              even use it to create your own GUI for the
;              chromium engine like this. It is just a
;              small browser-like example. Feel free to
;              open any page you want.
;
; You need the Awesomium SDK, install it somewhere and point
; to the library (DLL) shipped with it. Variable Awesomium_Path.s
; is used in this example.
;
; 
; todo: text search, login
;
; -|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-

IncludeFile "TabBarGadget.pbi" ; by STARGÅTE
IncludeFile "Awesomium.pbi"

Structure BrowserTab
  Awesomium.i
  Gadget.i
  Zoom.i
  Url.s
  FavIcon.i
  ResourceCount.i
  AmountData.i
  RequestTime.i
  ResponseTime.i
  LoadingStartTime.i
  DOMReadyTime.i
  LoadingTime.i
  ResourceAmount.i
EndStructure


Declare.i NewTab(ResetInput.i = #True)
Declare OpenTab(Pos.i, Url.s)

Global Window.i, Reload.i, Input.i, Zoom.i
Global Frame3D.i, Forward.i, Backward.i
Global StatusBar.i, TabBar.i, CurrentTab.i = -1
Global AddImage.i = CatchImage(#PB_Any, ?AddImage)
Global NewList BrowserTab.BrowserTab()
Global BrowserTabMutex.i = CreateMutex()


; ProcedureC InsertJQuery(*webview)
;   Protected *javascript, *js_object, *strUrl, Url.s
;   Protected Javascript.s = "scriptElement = document.createElement('script');"
;   Javascript + "typeAttr = document.createAttribute('type');"
;   Javascript + "typeAttr.nodeValue = 'text/javascript';"
;   Javascript + "scriptElement.setAttributeNode(typeAttr);"
;   Javascript + "srcAttr = document.createAttribute('src');"
;   Javascript + "srcAttr.nodeValue = 'http://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js';"
;   Javascript + "scriptElement.setAttributeNode(srcAttr);"
;   Javascript + "headerElement.appendChild(scriptElement);"
;   *javascript = awe_string_create_from_utf16(Javascript, Len(Javascript))
;   awe_webview_execute_javascript(*webview, *javascript, awe_string_empty())
;   awe_string_destroy(*javascript)
; EndProcedure


Procedure GetBrowserTab(Awesomium.i)
  Protected Result.i
  
  LockMutex(BrowserTabMutex)
  ForEach BrowserTab()
    If BrowserTab()\Awesomium = Awesomium
      Result = @BrowserTab()
      Break
    EndIf
  Next
  UnlockMutex(BrowserTabMutex)
  ProcedureReturn Result
EndProcedure


Procedure UpdateStatusBar(*BrowserTab.BrowserTab)
  Protected Timeframe.i = 0
  If *BrowserTab And *BrowserTab\Url
    If *BrowserTab\ResponseTime
      StatusBarText(StatusBar, 0,  "  response time: " + Str(*BrowserTab\ResponseTime) + " ms", #PB_StatusBar_BorderLess)
    Else
      StatusBarText(StatusBar, 0,  "   wait for answer ...", #PB_StatusBar_BorderLess)
    EndIf
    StatusBarText(StatusBar, 1,  "requests: " + Str(*BrowserTab\ResourceCount), #PB_StatusBar_Raised | #PB_StatusBar_Right)
    StatusBarText(StatusBar,  2, "amount: " + StrD(*BrowserTab\ResourceAmount / 1024, 3) + " kbytes", #PB_StatusBar_BorderLess)
    If *BrowserTab\DOMReadyTime = -1
      StatusBarText(StatusBar, 3, "DOM ready not fired", #PB_StatusBar_Raised | #PB_StatusBar_Right)
    Else
      StatusBarText(StatusBar, 3,"DOM ready fired after  " + Str(*BrowserTab\DOMReadyTime) + " ms", #PB_StatusBar_Raised | #PB_StatusBar_Right)
    EndIf
    If *BrowserTab\LoadingTime = -1
      While Timeframe < ElapsedMilliseconds() - *BrowserTab\RequestTime
        Timeframe + 10000  
      Wend
      StatusBarProgress(StatusBar, 4, ElapsedMilliseconds() - *BrowserTab\RequestTime, #PB_StatusBar_Raised, 0, Timeframe)
    Else
      StatusBarText(StatusBar, 4, "page loaded in " + StrD(*BrowserTab\LoadingTime / 1000, 3) + " seconds", #PB_StatusBar_Raised | #PB_StatusBar_Right)
    EndIf
  Else
    StatusBarText(StatusBar, 0, "", #PB_StatusBar_BorderLess)
    StatusBarText(StatusBar, 1, "", #PB_StatusBar_Raised)
    StatusBarText(StatusBar, 2, "", #PB_StatusBar_BorderLess)
    StatusBarText(StatusBar, 3, "", #PB_StatusBar_Raised)
    StatusBarText(StatusBar, 4, "", #PB_StatusBar_Raised)
  EndIf
EndProcedure

Procedure ExtLinkCallback(Awesomium.i, Url.s, Source.s)
  CurrentTab = NewTab()
  OpenTab(CurrentTab, Url)
EndProcedure

Procedure FaviconCallback(Awesomium.i, Favicon.i)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  Protected Count.i, i.i, OldIcon.i
  
  If *BrowserTab
    Count = CountTabBarGadgetItems(TabBar) - 1
    For i = 0 To Count
      If GetTabBarGadgetItemData(TabBar, i) =  *BrowserTab
        OldIcon = *BrowserTab\FavIcon
        *BrowserTab\FavIcon = Favicon
        If *BrowserTab\FavIcon 
          ResizeImage(*BrowserTab\FavIcon, 16, 16, #PB_Image_Smooth)
          SetTabBarGadgetItemImage(TabBar, i, ImageID(*BrowserTab\FavIcon))
        Else
          SetTabBarGadgetItemImage(TabBar, i, #Null)
        EndIf
        If OldIcon : FreeImage(OldIcon) : EndIf
        Break
      EndIf
    Next
  EndIf
EndProcedure

Procedure ContextMenuCallback(Awesomium.i, MouseX.i, MouseY.i, Type.i, MediaState.i, LinkUrl.s, SrcUrl.s, PageUrl.s, FrameUrl.s, SelectionText.s, IsEditable.i, EditFlags.i)
  Debug LinkUrl
  Debug SrcUrl
  Debug PageUrl
  Debug FrameUrl
  Debug SelectionText
EndProcedure

Procedure TitleCallback(Awesomium.i, Title.s, FrameName.s)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  Protected Count.i, i.i
  
  If *BrowserTab
    Count = CountTabBarGadgetItems(TabBar) - 1
    For i = 0 To Count
      If GetTabBarGadgetItemData(TabBar, i) = *BrowserTab
        SetTabBarGadgetItemText(TabBar, i, Title)
        ProcedureReturn
      EndIf
    Next
  EndIf
EndProcedure

Procedure LinkCallback(Awesomium.i, Url.s)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  
  Debug "New Link"
  If *BrowserTab
    *BrowserTab\RequestTime = ElapsedMilliseconds()
    *BrowserTab\ResponseTime = 0
    *BrowserTab\LoadingStartTime = 0
    *BrowserTab\DOMReadyTime = -1
    *BrowserTab\LoadingTime = -1
    *BrowserTab\ResourceCount = 0
    *BrowserTab\ResourceAmount = 0
    UpdateStatusBar(*BrowserTab)
  EndIf
EndProcedure

Procedure NewLinkCallback(Awesomium.i, Url.s, FrameName.s)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  Protected Tab.i
  
  If *BrowserTab
    If FrameName = ""
      Tab = CurrentTab
      If Tab <> -1 And GetTabBarGadgetItemData(TabBar, Tab) = *BrowserTab
        SetGadgetText(Input, Url)
      EndIf
      *BrowserTab\Url = Url
    EndIf
  EndIf
EndProcedure

Procedure BeginLoadingCallback(Awesomium.i, Url.s, FrameName.s, StatusCode.i, MimeType.s)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  
  Debug "begin loading"
  
  If FrameName = ""
    If *BrowserTab
      *BrowserTab\LoadingStartTime = ElapsedMilliseconds()
      *BrowserTab\ResponseTime = *BrowserTab\LoadingStartTime - *BrowserTab\RequestTime
      *BrowserTab\DOMReadyTime = -1
      *BrowserTab\LoadingTime = -1
      *BrowserTab\ResourceCount = 0
      *BrowserTab\ResourceAmount = 0
      UpdateStatusBar(*BrowserTab)
    EndIf
  EndIf
EndProcedure

Procedure DOMReadyCallback(Awesomium.i)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  
  If *BrowserTab
    *BrowserTab\DOMReadyTime = ElapsedMilliseconds() - *BrowserTab\LoadingStartTime
    UpdateStatusBar(*BrowserTab)
  EndIf
EndProcedure

Procedure FinishLoadingCallback(Awesomium.i)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  Protected Tab.i
  
  Debug "finish loading"
  If *BrowserTab
    Tab = CurrentTab
    If Tab <> -1 And GetTabBarGadgetItemData(TabBar, Tab) = *BrowserTab
      If Awesomium_HistoryBackwardCount(*BrowserTab\Awesomium)
        DisableGadget(Backward, #False)
      Else
        DisableGadget(Backward, #True)
      EndIf
      If Awesomium_HistoryForwardCount(*BrowserTab\Awesomium)
        DisableGadget(Forward, #False)
      Else
        DisableGadget(Forward, #True)
      EndIf
      UpdateStatusBar(*BrowserTab)
    EndIf
    *BrowserTab\LoadingTime = ElapsedMilliseconds() - *BrowserTab\LoadingStartTime
  EndIf
EndProcedure

Procedure PageContentsCallback(Awesomium.i, Url.s, Contents.s)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  Protected Tab.i
  Debug "page content loaded"
  ;fired after finish-loading
  If *BrowserTab
    Tab = CurrentTab
    If Tab <> -1 And GetTabBarGadgetItemData(TabBar, Tab) = *BrowserTab
      UpdateStatusBar(*BrowserTab)
    EndIf
    *BrowserTab\LoadingTime = ElapsedMilliseconds() - *BrowserTab\LoadingStartTime
  EndIf  
EndProcedure

Procedure ResourceCallback(Awesomium.i, Url.s, StatusCode.i, WasCached.i, RequestTimeMS.q, ResponseTimeMS.q, ExpectedContentSize.q, MimeType.s)
  Protected *BrowserTab.BrowserTab = GetBrowserTab(Awesomium)
  
  If *BrowserTab
    *BrowserTab\ResourceCount + 1
    *BrowserTab\ResourceAmount + ExpectedContentSize
    UpdateStatusBar(*BrowserTab)
  EndIf
EndProcedure

Procedure JSErrorCallback(ID.i, Message.s, LineNumber.i, Source.s)
  Debug "javscript error"
  Debug Message
  Debug LineNumber
  Debug Source
  Debug ""
  
EndProcedure

Procedure NewTab(ResetInput.i = #True)
  Protected *BrowserTab.BrowserTab
  
  If CurrentTab <> -1
    *BrowserTab = GetTabBarGadgetItemData(TabBar, CurrentTab)
    If *BrowserTab And *BrowserTab\Awesomium
      HideGadget(*BrowserTab\Gadget, #True)
    EndIf
  EndIf
  
  LockMutex(BrowserTabMutex)
  AddElement(BrowserTab())
  *BrowserTab = @BrowserTab()
  UnlockMutex(BrowserTabMutex)
  
  CurrentTab = AddTabBarGadgetItem(TabBar, #PB_Default, "New Tab")
  SetTabBarGadgetState(TabBar, CurrentTab)
  SetTabBarGadgetItemData(TabBar, CurrentTab, *BrowserTab)
  *BrowserTab\Zoom = Val(GetGadgetText(Zoom))
  If ResetInput : SetGadgetText(Input, "") : EndIf
  UpdateStatusBar(#Null)
  HideGadget(Frame3D, #False)
  DisableGadget(Backward, #True)
  DisableGadget(Forward, #True)
  
  ProcedureReturn *BrowserTab
EndProcedure

Procedure OpenTab(Pos.i, Url.s)
  Protected AweGadget.i, Gadget.i
  Protected *BrowserTab.BrowserTab
  
  HideGadget(Frame3D, #True)
  
  If LCase(Left(Url, 7)) <> "http://" And LCase(Left(Url, 8)) <> "local://"
    If Left(Url, 2) = "//"
      Url = "http:" + Url
    ElseIf Left(Url, 1) = "w"
      Url = "http://" + Url
    ElseIf Left(url, 1) = "."
      Url = "http://www" + Url
    Else
      Url = "http://www." + Url
    EndIf
  EndIf
  SetGadgetText(Input, Url)
  
  *BrowserTab = GetTabBarGadgetItemData(TabBar, Pos)
  If *BrowserTab And *BrowserTab\Awesomium
    *BrowserTab\Url = Url
    Awesomium_LoadUrl(*BrowserTab\Awesomium, *BrowserTab\Url)
  Else
    If Not *BrowserTab
      *BrowserTab = NewTab(#False)
    EndIf
    *BrowserTab\Awesomium = AwesomiumGadget(0, 60, WindowWidth(Window), WindowHeight(Window) - 60 - StatusBarHeight(StatusBar))
    *BrowserTab\Gadget = Awesomium_GetGadget(*BrowserTab\Awesomium)
    *BrowserTab\Url = Url
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_Title, @TitleCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_Favicon, @FaviconCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_OpenLink, @LinkCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_OpenNewLink, @NewLinkCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_OpenExtLink, @ExtLinkCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_ShowContextMenu, @ContextMenuCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_BeginLoading, @BeginLoadingCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_DomReady, @DOMReadyCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_JSMessage, @JSErrorCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_Resource, @ResourceCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_FinishLoading, @FinishLoadingCallback())
    Awesomium_Callback(*BrowserTab\Awesomium, #Awe_Callback_PageContents, @PageContentsCallback())
    Awesomium_Zoom(*BrowserTab\Awesomium, *BrowserTab\Zoom)
    Awesomium_LoadUrl(*BrowserTab\Awesomium, Url)
    
    UpdateStatusBar(*BrowserTab)
  EndIf
EndProcedure


Procedure CloseTab(Pos.i = -1)
  Protected CurrentTab.i, *BrowserTab.BrowserTab
  
  If Pos = -1 
    Pos = GetTabBarGadgetState(TabBar)
    SetGadgetText(Input, "")
  EndIf
  *BrowserTab = GetTabBarGadgetItemData(TabBar, Pos)
  If *BrowserTab
    Awesomium_Free(*BrowserTab\Awesomium)
    If *BrowserTab\FavIcon : FreeImage(*BrowserTab\FavIcon) : EndIf
    LockMutex(BrowserTabMutex)
    ChangeCurrentElement(BrowserTab(), *BrowserTab)
    DeleteElement(BrowserTab())
    UnlockMutex(BrowserTabMutex)
  EndIf
  RemoveTabBarGadgetItem(TabBar, Pos)
  CurrentTab = GetTabBarGadgetState(TabBar)
  If CurrentTab <> -1
    *BrowserTab = GetTabBarGadgetItemData(TabBar, CurrentTab)
    If *BrowserTab
      If *BrowserTab\Awesomium
        HideGadget(*BrowserTab\Gadget, #False)
        Awesomium_Zoom(*BrowserTab\Awesomium, *BrowserTab\Zoom)
      EndIf
      SetGadgetText(Input, *BrowserTab\Url)
      UpdateStatusBar(*BrowserTab)
    EndIf
  Else
    HideGadget(Frame3D, #False)
    UpdateStatusBar(#Null)
  EndIf
EndProcedure



; change this if you want to point to self downloaded installation of Awesomium
;Define Awesomium_Path.s = "<Awesomium SDK>\<Version>\build\bin\release\Awesomium.dll"
Define Awesomium_Path.s = GetPathPart(ProgramFilename()) + "Data\Awesomium\Awesomium.dll"

UseJPEGImageDecoder() 
UseJPEG2000ImageDecoder() 
UsePNGImageDecoder() 
UseTIFFImageDecoder() 
UseTGAImageDecoder() 

SetCurrentDirectory(GetPathPart(ProgramFilename()))
InitAwesomium(Awesomium_Path, "Awesomium - PureBasic", #True, GetPathPart(ProgramFilename()) + "Data")



#Menu_Input_Relead = 10
Define Event.i, *BrowserTab.BrowserTab
Define i.i, Count.i, *Awesomium

Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 1024, 768, "Awesomium - Browser Test", #PB_Window_MinimizeGadget | #PB_Window_MaximizeGadget | #PB_Window_ScreenCentered | #PB_Window_SizeGadget)
SmartWindowRefresh(Window, #True)
Reload = ButtonGadget(#PB_Any, 5, 5, 70, 25, "Reload")
Backward = ButtonGadget(#PB_Any, 80, 5, 25, 25, "<")
Forward = ButtonGadget(#PB_Any, 110, 5, 25, 25, ">")
Input = StringGadget(#PB_Any, 145, 8, WindowWidth(Window) - 10 - 140 - 60, 20, "")
AddKeyboardShortcut(Window, #PB_Shortcut_Return, #Menu_Input_Relead)
Zoom = ComboBoxGadget(#PB_Any, WindowWidth(Window) - 55, 8, 50, 20) 
For i = 20 To 200 Step 20 
  AddGadgetItem(Zoom, -1, Str(i) + "%")
Next
For i = 300 To 500 Step 100
  AddGadgetItem(Zoom, -1, Str(i) + "%")
Next
SetGadgetState(Zoom, 4)
TabBar = TabBarGadget(#PB_Any, 5, 35, WindowWidth(Window) - 10, 25, #TabBarGadget_CloseButton)
AddImage = CatchImage(#PB_Any, ?AddImage)
AddTabBarGadgetItem(TabBar, #TabBarGadgetItem_EmptyButton, "", ImageID(AddImage))

StatusBar = CreateStatusBar(#PB_Any, WindowID(Window))
AddStatusBarField(150)
AddStatusBarField(#PB_Ignore)
AddStatusBarField(#PB_Ignore)
AddStatusBarField(#PB_Ignore)
AddStatusBarField(300)

Frame3D = ContainerGadget(#PB_Any, 0, 60, WindowWidth(Window), WindowHeight(Window) - 60 - StatusBarHeight(StatusBar), #PB_Container_Single)
CloseGadgetList()

; load local Main.html at startup
NewTab()
OpenTab(CurrentTab, "local://Main.html")
; ---

Repeat
  Awesomium_Update()

  Event =  WaitWindowEvent(10)
  Select Event
    Case #PB_Event_CloseWindow
      Break
    Case #PB_Event_SizeWindow
      Count = CountTabBarGadgetItems(TabBar) - 1
      LockMutex(BrowserTabMutex)
      ForEach BrowserTab()
        If BrowserTab()\Awesomium
          Awesomium_Resize(BrowserTab()\Awesomium, #PB_Ignore, #PB_Ignore, WindowWidth(Window), WindowHeight(Window) - 60 - StatusBarHeight(StatusBar))
        EndIf
      Next
      UnlockMutex(BrowserTabMutex)
      ResizeGadget(Input, 145, 8, WindowWidth(Window) - 10 - 140 - 60, 20)
      ResizeGadget(Zoom, WindowWidth(Window) - 55, 8, 50, 20)
      ResizeGadget(TabBar, 5, 35, WindowWidth(Window)-10, 25)
      ResizeGadget(Frame3D, 0, 60, WindowWidth(Window), WindowHeight(Window) - 60 - StatusBarHeight(StatusBar))
      TabBarGadget_Update(TabBar)
      
    Case #PB_Event_Menu
      If EventMenu() = #Menu_Input_Relead
        OpenTab(CurrentTab, GetGadgetText(Input))
      EndIf
      
    Case #PB_Event_Gadget
      Select EventGadget()
        Case Reload
          OpenTab(CurrentTab, GetGadgetText(Input))
        Case Zoom
          If CurrentTab <> -1
            *BrowserTab = GetTabBarGadgetItemData(TabBar, CurrentTab)
            *BrowserTab\Zoom = Val(GetGadgetText(Zoom))
            If *BrowserTab\Awesomium
              Awesomium_Zoom(*BrowserTab\Awesomium, *BrowserTab\Zoom)
            EndIf
          EndIf
          
        Case Backward
          If CurrentTab <> -1
            *BrowserTab = GetTabBarGadgetItemData(TabBar, CurrentTab)
            If *BrowserTab And *BrowserTab\Awesomium
              If Not Awesomium_HistoryGoTo(*BrowserTab\Awesomium, -1)
                DisableGadget(Backward, #True)
              Else
                DisableGadget(Forward, #False)
              EndIf
            EndIf
          EndIf
          
        Case Forward
          If CurrentTab <> -1
            *BrowserTab = GetTabBarGadgetItemData(TabBar, CurrentTab)
            *BrowserTab\Zoom = Val(GetGadgetText(Zoom))
            If *BrowserTab\Awesomium
              If Not Awesomium_HistoryGoTo(*BrowserTab\Awesomium, 1)
                DisableGadget(Forward, #True)
              Else 
                DisableGadget(Backward, #False)
              EndIf
            EndIf
          EndIf
          
          
        Case TabBar
          Select TabBarGadgetEvent(TabBar)
            Case #TabBarGadget_Event_NewTab
              NewTab()
              
            Case #TabBarGadget_Event_Change
              If CurrentTab <> -1
                *BrowserTab = GetTabBarGadgetItemData(TabBar, CurrentTab)
                If *BrowserTab And *BrowserTab\Gadget
                  HideGadget(*BrowserTab\Gadget, #True)
                EndIf
                SetGadgetText(Input, "")
              EndIf
              CurrentTab = GetTabBarGadgetState(TabBar)
              If CurrentTab <> -1
                *BrowserTab = GetTabBarGadgetItemData(TabBar, CurrentTab)
                If *BrowserTab And *BrowserTab\Awesomium
                  HideGadget(*BrowserTab\Gadget, #False)
                EndIf
                SetGadgetText(Zoom, Str(*BrowserTab\Zoom) + "%")
                SetGadgetText(Input, *BrowserTab\Url)
                UpdateStatusBar(*BrowserTab)
                If Awesomium_HistoryBackwardCount(*BrowserTab\Awesomium)
                  DisableGadget(Backward, #False)
                Else
                  DisableGadget(Backward, #True)
                EndIf
                If Awesomium_HistoryForwardCount(*BrowserTab\Awesomium)
                  DisableGadget(Forward, #False)
                Else
                  DisableGadget(Forward, #True)
                EndIf  
              Else
                DisableGadget(Backward, #True)
                DisableGadget(Fordward, #True)
                SetGadgetText(Input, "")
                UpdateStatusBar(#Null)
              EndIf
              
            Case #TabBarGadget_Event_CloseTab
              CloseTab(EventTab(TabBar))
              CurrentTab = GetTabBarGadgetState(TabBar)
              
          EndSelect
          
       Default
        *Awesomium = Awesomium_GetAwesomium(EventGadget(), #Awe_Type_Gadget) 
        If *Awesomium
          Awesomium_GadgetEvent(*Awesomium, EventType())
          Count = CountTabBarGadgetItems(TabBar) - 1
          For i = 0 To Count
            If GetTabBarGadgetItemData(TabBar, i) = *Awesomium
              ;SetTabBarGadgetItemText(TabBar, i, GetAwesomiumTitle(EventGadget()))
              
              Break
            EndIf
          Next
          
        EndIf
        
     EndSelect
  EndSelect
ForEver

Awesomium_Shutdown()
End

; Image by STARGÅTE
DataSection
	AddImage:
	Data.q $0A1A0A0D474E5089,$524448490D000000,$1000000010000000,$FFF31F0000000608,$5845741900000061
	Data.q $72617774666F5374,$2065626F64410065,$6165526567616D49,$00003C65C9717964,$DA78544144495C02
	Data.q $3D105153684B53A4,$4B1A4987926D36F7,$B65D8DC160B44B69,$5742911161FC1115,$EC4445828A082775
	Data.q $175A845C2E170B22,$A576764A0A17155A,$B48685C42E94DC14,$098D20B442C54A90,$9D3EFBE6D24D34F9
	Data.q $7985E1705315F979,$E6733339CEE777DC,$1FC2CB3FF030C30A,$54860CD2E0E34421,$47B34328C75D3E0D
	Data.q $7F3BCC81624DA04A,$4FCC2E4CBBF54B0F,$380FBB9E34E2E00D,$07FAC70373395D6F,$C89147CAD8735651
	Data.q $8ABC30421EB4206C,$16E5C29F9B9B4572,$F137D839E77E0A00,$5E58B7912B1F9AEC,$F295807672A4A3F7
	Data.q $31617453B0063A54,$4C99417B594282B4,$4D87218B1EC60036,$498FE2C7EEB93E09,$A9CEE0755063B6A4
	Data.q $8811B0167E9E7F6A,$2D75F0BBA648ED14,$92C6BB87F0C74D06,$C646C68F15150BE4,$2A310AA42BCFEDF1
	Data.q $FF46C6816D9BD018,$6EBD136576055B46,$39DDAC9F61986BF2,$268FC9C230E7A477,$F780137A4A229973
	Data.q $38652BB24B872A45,$A2702A1B67BBB315,$91CDC4ECEA8B6D25,$5FA94DD3DE548B74,$2AB2FABA95530B2E
	Data.q $BFE4584049D99023,$54802481CCFB9785,$E0625989B1D50A36,$EF8D2A89EF5D3832,$0958DEA76895308B
	Data.q $B4F131D1F5046680,$3745182FE8E10212,$64D1DACC93AA566C,$72019B2FB19F3DE1,$7E4800D022292279
	Data.q $C3A13247122D6F87,$F0026966CC2C25D0,$88171E2ACA34CF9E,$36BF2CC629C40DA6,$C6EAE378FBF9CA48
	Data.q $470E8F77448F51C4,$6299009AF5B2E017,$467E04C70514B90C,$AB88785B98E2640D,$1E17FDCA3BDF9B14
	Data.q $80B73ED189D2B5E0,$0AE78EE4EA346EC3,$C7453C19A4EDE655,$71C181AD02DE5BBF,$8E3B16DB8C343C9C
	Data.q $2360405AB762A5D7,$FBC1C4F8F7D5D988,$3990F131E2DAA63E,$EFCB21164B3012FF,$4CDC000C02BB8D7D
	Data.q $0000B1AFD4924B07,$42AE444E45490000,$0000000000008260
EndDataSection
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 418
; FirstLine = 360
; Folding = ---
; EnableUnicode
; EnableXP
; DisableDebugger
; CompileSourceDirectory