﻿; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
;         Awesomium - Browser Framework based on Chromium
;
;                                        Sprite3D example
;
; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
; from: 16.02.2012
; Version 0.04.00
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
;
; © 2012 by PMV 
; 
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
; thread: http://www.purebasic.fr/english/viewtopic.php?f=12&t=48283
;
; description: shows how awesomium can be used to display it
;              as a Sprite3D with mouse-interaction. To close
;              the window just pres the close-button top right
;              inside of the website.
;
; You need the Awesomium SDK, install it somewhere and point
; to the library (DLL) shipped with it. Variable Awesomium_Path.s
; is used in this example.
;
; 
; todo: keyboard input and a little animation
;
; -|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-

;- Example 
IncludeFile "Awesomium.pbi"

Global EndProgram = #False
Procedure JSCallback(ID.i, ObjectName.s, CallbackName.s, *Arguments)
  Select ObjectName
    Case "btnClose"
      EndProgram = #True
  EndSelect
EndProcedure

Procedure TitleCallback(Awesomium.i, Title.s, FrameName.s)
  If FrameName = ""
    Awesomium_JS_InnerText(Awesomium, FrameName, "title", Title)
  EndIf
EndProcedure

Procedure.i ResourceRequestCallback(Awesomium.i, *Request.Awesomium_Request)
  Debug "call to MyRequest.html"
  Awesomium_CancleRequest(*Request)
  
  ForEach *Request\Element()
    Debug MapKey(*Request\Element()) + " = " + *Request\Element()
  Next

  ProcedureReturn #Null
EndProcedure

; change this if you want to point to self downloaded installation of Awesomium
;Define Awesomium_Path.s = "<Awesomium SDK>\<Version>\build\bin\release\Awesomium.dll"
Define Awesomium_Path.s = GetPathPart(ProgramFilename()) + "Data\Awesomium\Awesomium.dll"

InitMouse()
InitSprite()
InitSprite3D()


SetCurrentDirectory(GetPathPart(ProgramFilename()))
InitAwesomium(Awesomium_Path, "Awesomium - Test", #True, GetPathPart(ProgramFilename()) + "Data", "self", "", 0, #True)


Define Window.i, Awesomium.i, Event.i, MouseSprite.i
Window = OpenWindow(#PB_Any, #PB_Ignore, #PB_Ignore, 1024, 768, "Awesomium - Sprite3D", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
OpenWindowedScreen(WindowID(Window), 0, 0, 1024, 768, #False, 0, 0)
Sprite3DQuality(#PB_Sprite3D_NoFiltering)

;Awesomium = CreateAwesomiumSprite(1024, 1024, #PB_Sprite_AlphaBlending)
Awesomium = CreateAwesomiumSprite3D(1024, 1024, RGB(255, 0, 255))
;Awesomium_LoadUrl(Awesomium, "http://tumblr.gesteves.com/post/475773360/css-glow-effects-With-box-shadow")
;Awesomium_LoadUrl(Awesomium, "http://www.webkit.org/blog/138/css-animation/")


Awesomium_RegisterObject(Awesomium, "btnClose")
Awesomium_RegisterObjectCallback(Awesomium, "btnClose", "close")
Awesomium_Callback(Awesomium, #Awe_Callback_JSCallback, @JSCallback())
Awesomium_Callback(Awesomium, #Awe_Callback_Title, @TitleCallback())
Awesomium_ResourceRequestCallback(Awesomium, "MyRequest.html", @ResourceRequestCallback())
Awesomium_LoadFile(Awesomium, "Main.html")

MouseSprite = CreateSprite(#PB_Any, 8, 8)
StartDrawing(SpriteOutput(MouseSprite))
  Box(0, 0, 7, 7, 0)
  Circle(3, 3, 2, RGB(4, 4, 4))
  Box(3, 3, 1, 1, RGB(255, 255, 255))
StopDrawing()
TransparentSpriteColor(MouseSprite, 0) 



LoadSprite(0, #PB_Compiler_Home + "\Examples\Sources\Data/Geebee2.bmp", #PB_Sprite_Texture)
CreateSprite3D(0, 0)
CreateSprite3D(1, 0)
CreateSprite3D(2, 0)

Sprite3DQuality(0)

TransparentSpriteColor(0, RGB(255, 0, 255)) ; Our pink is transparent :)

Define x.i

Repeat
  ExamineMouse()
  Awesomium_InjectMousePos(Awesomium, MouseX(), MouseY())
  Awesomium_InjectMouseButtonDX(Awesomium)

  Awesomium_Update()
    
  Event =  WaitWindowEvent(100)
  Select Event
    Case #PB_Event_CloseWindow
      Break
  EndSelect
  
  
  ClearScreen(0)
    If Start3D()
      DisplaySprite3D(0, 0, 30)
      DisplaySprite3D(0, x+100, 100, x)
      DisplaySprite3D(0, x*2, 100, x)

      ; Zoom..
      ;
      ZoomSprite3D(1, x, x)
      RotateSprite3D(1, x, 0)
      DisplaySprite3D  (1, 0, 100, x/2)
      DisplaySprite3D  (1, x*2, 100, x)
      DisplaySprite3D  (1, 0, 100, x/2)
      DisplaySprite3D  (1, x*2, 200+x, x)
      ;DisplaySprite3D(Awesomium_GetSprite3D(Awesomium), 0, 0)
      Stop3D()
    EndIf
  DisplayTransparentSprite(Awesomium_GetSprite(Awesomium), 0, 0)
  

  DisplayTransparentSprite(MouseSprite, MouseX(), MouseY())
  
  FlipBuffers()
  x = (x + 1) % 1024
Until EndProgram
Awesomium_Shutdown()
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 146
; FirstLine = 66
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory