﻿; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
;         Awesomium - Browser Framework based on Chromium
;
;                               standalone window example
;
; -:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-:-
;
; from: 16.02.2012
; Version 0.04.00
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
;
; © 2012 by PMV 
; 
;
; {|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}-{|}
;
; thread: http://www.purebasic.fr/english/viewtopic.php?f=12&t=48283
;
; description: shows how Awesomium can be used to display it
;              as a standalone window. Remember, it is a full
;              browser-engine, so you can display here 
;              everything, what Chrome can render.
;
; You need the Awesomium SDK, install it somewhere and point
; to the library (DLL) shipped with it. Variable Awesomium_Path.s
; is used in this example.
;
; -|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-|-


IncludeFile "Awesomium.pbi"

Global EndProgram = #False
Procedure JSCallback(ID.i, ObjectName.s, CallbackName.s, *Arguments)
  Select ObjectName
    Case "btnClose"
      EndProgram = #True
  EndSelect
EndProcedure

Procedure TitleCallback(Awesomium.i, Title.s, FrameName.s)
  If FrameName = ""
    Awesomium_JS_InnerText(Awesomium, FrameName, "title", Title)
  EndIf
EndProcedure

Procedure.i ResourceRequestCallback(Awesomium.i, *Request.Awesomium_Request)
  Debug "call to MyRequest.html"
  Awesomium_CancleRequest(*Request)
  
  ForEach *Request\Element()
    Debug MapKey(*Request\Element()) + " = " + *Request\Element()
  Next

  ProcedureReturn #Null
EndProcedure

Procedure JSErrorCallback(ID.i, Message.s, LineNumber.i, Source.s)
  Debug "Error"
  Debug Message
  Debug LineNumber
  Debug Source
  Debug ""
  
EndProcedure

; change this if you want to point to self downloaded installation of Awesomium
;Define Awesomium_Path.s = "<Awesomium SDK>\<Version>\build\bin\release\Awesomium.dll"
Define Awesomium_Path.s = GetPathPart(ProgramFilename()) + "Data\Awesomium\Awesomium.dll"


SetCurrentDirectory(GetPathPart(ProgramFilename()))
InitAwesomium(Awesomium_Path, "Awesomium - Test", #True, GetPathPart(ProgramFilename()) + "Data")



Define Awesomium.i, Gadget.i, Event.i
Awesomium = OpenAwesomiumWindow(0, 0, 1024, 1024, "Awesomium + PureBasic - Browser Example")
;Awesomium_LoadUrl(Awesomium, "http://tumblr.gesteves.com/post/475773360/css-glow-effects-With-box-shadow")
;Awesomium_LoadUrl(Awesomium, "http://www.webkit.org/blog/138/css-animation/")

Awesomium_RegisterObject(Awesomium, "btnClose")
Awesomium_RegisterObjectCallback(Awesomium, "btnClose", "close")
Awesomium_Callback(Awesomium, #Awe_Callback_JSCallback, @JSCallback())
Awesomium_Callback(Awesomium, #Awe_Callback_Title, @TitleCallback())
Awesomium_ResourceRequestCallback(Awesomium, "MyRequest.html", @ResourceRequestCallback())
Awesomium_LoadFile(Awesomium, "Main.html")



Repeat
  Awesomium_Update()

  Event =  WaitWindowEvent(10)
  Select Event
    Case #PB_Event_CloseWindow
      Break
  EndSelect
Until EndProgram
Awesomium_Shutdown()
; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 72
; FirstLine = 14
; Folding = -
; EnableUnicode
; EnableXP
; CompileSourceDirectory